/***************************************************************************************
	Copyright 2000-2001 ATMEL Corporation.
	
	This file is part of atmel wireless lan drivers.

    Atmel wireless lan drivers is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Atmel wireless lan drivers is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Atmel wireless lan drivers; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**************************************************************************************/
#include <menu.h>
#include <signal.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>	/* For AF_INET & struct sockaddr */

#define CALLER_COFVNET

#include "strdefs.h"
#include "vnet.h"

#undef CALLER_COFVNET

#define PCMCIA  0
#define USB	1


extern int wep_reverse;
extern WINDOW *wep_win;


int reverse;
int epilogh = 0;
int config_choices = sizeof(conf_choices) / sizeof(char *);

void init_all_pairs()
{
	init_pair(1, COLOR_RED, COLOR_BLACK);
	init_pair(2, COLOR_BLUE, COLOR_BLACK);
	init_pair(3, COLOR_YELLOW, COLOR_BLACK);
    	init_pair(4, COLOR_CYAN, COLOR_BLACK);
}

void read_ioctls_wlan(PDEVICE_CONFIGURATION pAppInfo, PENCRYPTION_INFO pEncryptionInfo,
		      int fd, char *cname)
{
	int d, utruth = 0;

	reverse = 1;
	conf_win = create_newwin(WINHEIGHT, WIDTH, 6, 0); 
	keypad(conf_win, TRUE);
	refresh();
	print_my_menu(conf_win, reverse);

	while (1) {
		d = wgetch(conf_win);
		utruth = 0;
		switch (d) {
		case KEY_UP:
			if (reverse == 1)
				reverse = config_choices;
			else
				--reverse;
			break;
		case KEY_DOWN:
			if (reverse == config_choices)
				reverse = 1;
			else
				++reverse;
			break;
		case 10:
			epilogh = reverse;
			utruth = 1;
			break;
		default:
			refresh();
			break;
		}
		print_my_menu(conf_win, reverse);
		if (d == KEY_F(1)) {	/* User did a choice come out of the infinite loop */
			wclear(conf_win);
			destroy_win(conf_win);
			break;

		}
		if (utruth == 1) {
			if (epilogh == 11) {	/* User did a choice come out of the infinite loop */
				wclear(conf_win);
				destroy_win(conf_win);
				utruth = 0;
				break;

			}


			switch (epilogh) {
			case 1:	// Set ESSID NAME
				Set_ESSID(pAppInfo, cname, fd);
				refresh();
				break;
			case 2:	// Set Channel
				Set_Channel(pAppInfo, cname, fd);
				refresh();
				break;
			case 3:	// Set Radio 
				Set_Radio(pAppInfo, cname, fd);
				refresh();
				break;
			case 4:	// Set InternationalRoaming 
				Set_InternationalRoaming(pAppInfo, cname, fd);
				refresh();
				break;
			case 5:	// Transmit Rate...
				Set_TxRate(pAppInfo, cname, fd);
				refresh();
				break;
			case 6:	// Operating Mode
				Set_OpMode(pAppInfo, cname, fd);
				refresh();
				break;
			case 7:	// Preamble Type
				Set_Preamble(pAppInfo, cname, fd);
				refresh();
				break;
			case 8:	// PowerMgmtMode Threshold
				Set_PowerMgmtMode(pAppInfo, cname, fd);
				refresh();
				break;
			case 9:	// Fragmentation Threshold
				Set_FragT(pAppInfo, cname, fd);
				refresh();
				break;
			case 10:// Rts Threshold
				Set_RtsT(pAppInfo, cname, fd);
				refresh();
				break;
			default:
				break;
			}
			utruth = 0;
		}
	}
}
int WEP_KEY_CONV(int value, PUCHAR W_KEY)
{
	WINDOW *wep_key_val;
	int coun;
	int a, b, d;
	UCHAR Get_Arg[2 * LONG_WEP_KEY_SIZE + 1], size;
	char c;
	b = 0;
	a = 0;
	size = (W_KEY[0] == 1) ? 5 : 13;
	wep_key_val = newwin(WINHEIGHT, WIDTH, 6, 0);
	box(wep_key_val, 0, 0);
	mvwhline(wep_key_val, 2, 1, ACS_HLINE, WIDTH-2);
	wattron(wep_key_val, A_BOLD);
	wattron(wep_key_val, COLOR_PAIR(2)); //CHNG
	mvwprintw(wep_key_val, 1, 18, "Give Wep Key ( %i ) value", value);
	wattroff(wep_key_val, COLOR_PAIR(2));

	CancelExit(wep_key_val, 1, 46);

	for (coun = 0; coun < size; coun++) {
		mvwprintw(wep_key_val, 3 + coun, 1,
			  "Byte %02d (two characters) \t: ", coun + 1);
		wrefresh(wep_key_val);
		for (a = 0; a < 2; a++) {
			echo();
			c = wgetch(wep_key_val);
			noecho();
			Get_Arg[a] = toupper(c);
			if ((Get_Arg[a] < 0x30) ||
			    ((Get_Arg[a] > 0x39) && (Get_Arg[a] < 0x41)) ||
			    (Get_Arg[a] > 0x46)) {
				return -1;
			}
			wrefresh(wep_key_val);
		}
		wrefresh(wep_key_val);
		W_KEY[b] = AsciiToByte(Get_Arg[0], Get_Arg[1]);
		b++;
	}
	while ((d = getch())) {
		if (d == 10) {
			wclear(wep_key_val);
			destroy_win(wep_key_val);
			print_wep_menu(wep_win, wep_reverse);
			break;
		}
	}

	wattroff(wep_key_val, A_BOLD);
	return 0;
}

UCHAR AsciiToByte(UCHAR Ascii1, UCHAR Ascii2)
{
	UCHAR digit1=0, digit2=0;

	if (Ascii1 >= 0x30 && Ascii1 <= 0x39)
		digit1 = Ascii1 - 0x30;
	else if (Ascii1 >= 0x41 && Ascii1 <= 0x46)
		digit1 = Ascii1 - 0x31 - 6;

	if (Ascii2 >= 0x30 && Ascii2 <= 0x39)
		digit2 = Ascii2 - 0x30;
	else if (Ascii2 >= 0x41 && Ascii2 <= 0x46)
		digit2 = Ascii2 - 0x31 - 6;

	return (digit1 << 4) + digit2;
}

// Wep Key Information... Details available only if a wep key is used
int Get_Wep(PENCRYPTION_INFO pEncryptionInfo, int fd, char *cname)
{
	struct iwreq wrq;
	unsigned char key[IW_ENCODING_TOKEN_MAX];

	strcpy(wrq.ifr_name, cname);

	wrq.u.data.pointer = (caddr_t) key;
	wrq.u.data.length=IW_ENCODING_TOKEN_MAX;
	wrq.u.data.flags=0;
	if(ioctl(fd, SIOCGIWENCODE, &wrq) < 0) {
		ErrorWin("Failed to Get Encryption Info");
		return -1;
	}

		pEncryptionInfo->WepKeyToUse = (wrq.u.data.flags & 0x7) -1;
		//if(pEncryptionInfo->WepKeyToUse < 0 || pEncryptionInfo->WepKeyToUse > 3) return -1;
		pEncryptionInfo->EncryptionLevel = /*wrq.u.data.length; */ (wrq.u.data.flags & IW_ENCODE_DISABLED) ? 
			0 : (wrq.u.data.length == 5 ? WEP_64BIT : WEP_128BIT ) ;
		pEncryptionInfo->AuthenticationType = (wrq.u.data.flags & IW_ENCODE_OPEN) ? C80211_MGMT_AAN_OPENSYSTEM : C80211_MGMT_AAN_SHAREDKEY;
		//pEncryptionInfo->EncryptionLevel = (wrq.u.data.length == 5) ? WEP_64BIT : WEP_128BIT;
	//	memcpy((PUCHAR)pEncryptionInfo->KeyMaterial[pEncryptionInfo->WepKeyToUse], (PUCHAR)wrq.u.data.pointer, wrq.u.data.length);
		// FIXME: also passed as reference
		if(pEncryptionInfo->EncryptionLevel)
			memcpy((PUCHAR)pEncryptionInfo->KeyMaterial[pEncryptionInfo->WepKeyToUse], (PUCHAR)wrq.u.data.pointer, wrq.u.data.length);	
	return 0;
}

int Get_Config(PDEVICE_CONFIGURATION pAppInfo, int fd, char *cname)
{
	struct iwreq wrq;

	strcpy(wrq.ifr_name, cname);
	wrq.u.data.pointer = (caddr_t) pAppInfo;
	wrq.u.data.length = 0;	//sizeof(DEVICE_CONFIGURATION);//0;
	wrq.u.data.flags = GET_SUPPORT_INFO;
	return ioctl(fd, SIOCDEVPRIVATE, &wrq);
	// OK, DEVPRIVATE
}

int Get_Stats(PSTATISTICS pStats, int fd, char *cname)
{
	struct iwreq wrq;

	strcpy(wrq.ifr_name, cname);
	wrq.u.data.pointer = (caddr_t) pStats;
	wrq.u.data.length = 0;
	wrq.u.data.flags = GET_STATISTICS;
	return ioctl(fd, SIOCDEVPRIVATE, &wrq);
	// OK, DEVPRIVATE
}

int Get_Ver(PVERSION_INFO pVersionInfo, int fd, char *cname)
{
	struct iwreq wrq;

	strcpy(wrq.ifr_name, cname);

	wrq.u.data.pointer = (caddr_t) pVersionInfo;
	wrq.u.data.length = 0;
	wrq.u.data.flags = GET_VERSION_INFO;
	return ioctl(fd, SIOCDEVPRIVATE, &wrq);
	// OK, DEVPRIVATE
}


int Get_APs(BSS_INFO_EX *AP, int fd, char *cname) 
{
	int APsFound=0, i;
  	struct iwreq wrq;
	struct iw_event * piwe;
	unsigned char buff[IW_SCAN_MAX_DATA];
	unsigned char* index=buff;

	strcpy(wrq.ifr_name, cname);

	wrq.u.data.length = sizeof(buff);
	wrq.u.data.pointer = (caddr_t)buff;
	wrq.u.data.flags = 0;

	// no-response timeout is 10 seconds
	for(i=0; ioctl(fd, SIOCGIWSCAN, &wrq) && i<10; i++) sleep(1);

	while(index < buff+wrq.u.data.length)	 {	
		piwe = (struct iw_event*)index;
		switch(piwe->cmd) {
			case SIOCGIWAP:
				memcpy(AP[APsFound].BSSID, piwe->u.ap_addr.sa_data, 6);
				break;
			case SIOCGIWESSID:
				AP[APsFound].SSIDsize = piwe->u.data.length;
                		memcpy(AP[APsFound].SSID, (char*)piwe+IW_EV_POINT_LEN, piwe->u.data.length);
				break;
			case SIOCGIWMODE:
                		AP[APsFound].BSStype= piwe->u.mode;
				break;
			case SIOCGIWFREQ:
                		AP[APsFound].Channel= piwe->u.freq.m;
				break;
			case SIOCGIWENCODE:
				AP[APsFound].UsingWEP= (piwe->u.data.flags & IW_ENCODE_DISABLED ? 0: 1);
				APsFound++;
				break;
			default:
				if(!piwe->len) return APsFound; // deadlock preventer
				break;
		}
		index += (int) (piwe->len);
	} 
	return APsFound; 
}


void Print_Stats(WINDOW * conf_win, PDEVICE_CONFIGURATION pAppInfo,
		 PENCRYPTION_INFO pEncryptionInfo, PSTATISTICS pStatistics)
{
	int i;
	char ch = ' ';

	HEADER( conf_win, "Current Statistics" )
  mvwprintw(conf_win, 3, 1,
		  "Successfull Transmit Packets\t: %d      ",
		  pStatistics->TxDataPacketsOk);
	mvwprintw(conf_win, 4, 1, "Error Transmit Packets\t\t: %d    ",
		  pStatistics->TxDataPacketsError);
	mvwprintw(conf_win, 5, 1,
		  "Successfully Received Packets\t: %d      ",
		  pStatistics->RxDataPacketsOk);
	mvwprintw(conf_win, 6, 1, "Error Received Packets \t: %d         ",
		  pStatistics->RxDataPacketsError);

	DisplayDriverState(conf_win, pAppInfo->StationState,
			   pAppInfo->OperatingMode, pAppInfo->MgmtErrorCode);

	if ((pAppInfo->StationState == 0x05)
	    && (pAppInfo->OperatingMode == 1)) {
		mvwprintw(conf_win, 9, 34, "BSSID : ");
		for (i = 0; i < 6; i++)
			mvwprintw(conf_win, 9, 42 + (i * 3), "%02X-",
				  pAppInfo->BSSID[i]);
		mvwprintw(conf_win, 9, 60, "\b ");
	}
	mvwprintw(conf_win, 10, 1, "Channel \t\t\t: %d",
		  pAppInfo->Channel);
	mvwprintw(conf_win, 11, 1, "SSID	\t\t\t: ");
	for (i = 0; i < pAppInfo->SSIDlength; i++)
		mvwprintw(conf_win, 11, 34 + i, "%c", pAppInfo->SSID[i]);
	for (i = pAppInfo->SSIDlength; i < 32; i++)
		mvwprintw(conf_win, 11, 34 + i, "%c", ch);

	i=pAppInfo->TxRate;
	if(i>=0 && i<=4) // Testing to avoid pointer out of range
		mvwprintw(conf_win, 12, 1, 
		  "Transmit rate	\t\t: %s", txrate[pAppInfo->TxRate]);
	i=pAppInfo->OperatingMode;
	if(i>=0 && i<=3) // Testing to avoid pointer out of range
		mvwprintw(conf_win, 13, 1, 
		  "Operating Mode\t\t\t: %s", opermode[pAppInfo->OperatingMode]);
	i=pAppInfo->RadioIsOn;
	if(i==0 || i==1) // Testing to avoid pointer out of range
		mvwprintw(conf_win, 14, 1,
		  "Radio \t\t\t\t: %s", offon[pAppInfo->RadioIsOn] );
	i=pAppInfo->PowerMgmtMode;
	if(i>=0 && i<=2) // Testing to avoid pointer out of range
		mvwprintw(conf_win, 15, 1,
		  "Power Mode\t\t\t: %s",powermode[pAppInfo->PowerMgmtMode]);
	i=pAppInfo->InternationalRoaming;
	if(i==0 || i==1) // Testing to avoid pointer out of range
		mvwprintw(conf_win, 16, 1, "International Roaming \t\t: %s",
  		  dis_enable[pAppInfo->InternationalRoaming]);
}

void Print_Wep_Stats(WINDOW * wep_win, PENCRYPTION_INFO pEncryptionInfo, PDEVICE_CONFIGURATION pAppInfo,
		     PSTATISTICS pStatistics)
{
	int i;
	UCHAR size_used = 0;
	wep_win = create_newwin(WINHEIGHT, WIDTH, 6, 0); 
	wattron(wep_win, A_BOLD);
	mvwhline(wep_win, 2, 1, ACS_HLINE, WIDTH-2); 
	wattron(wep_win, COLOR_PAIR(2));
	mvwprintw(wep_win, 1, 5, "Wep Key Information (");
	wrefresh(wep_win);
	if (pEncryptionInfo->EncryptionLevel) {
		mvwprintw(wep_win, 1, 26, "Enabled - Encryption Level %s)",
			  (pEncryptionInfo->EncryptionLevel ==
			   1) ? "64-bit" : "128-bit");
		wattroff(wep_win, COLOR_PAIR(2));
		//mvwprintw(wep_win, 4, 1, "Wep Key Used\t\t: ");
		mvwprintw(wep_win, 4, 1, "Transmission Key\t: ");
		wrefresh(wep_win);
		switch (pEncryptionInfo->WepKeyToUse) {
		case 0:
			mvwprintw(wep_win, 4, 26, "One");
			wrefresh(wep_win);
			break;
		case 1:
			mvwprintw(wep_win, 4, 26, "Two");
			wrefresh(wep_win);
			break;
		case 2:
			mvwprintw(wep_win, 4, 26, "Three");
			wrefresh(wep_win);
			break;
		case 3:
			mvwprintw(wep_win, 4, 26, "Four");
			wrefresh(wep_win);
			break;
		case 4:
			mvwprintw(wep_win, 4, 26, "None");
			wrefresh(wep_win);
			break;
		}
	} else {
		wattron(wep_win, COLOR_PAIR(1)); 
		mvwprintw(wep_win, 1, 35, "Disabled");
		wattroff(wep_win, COLOR_PAIR(1));
		wattron(wep_win, COLOR_PAIR(2));
		mvwprintw(wep_win, 1, 52, ")");
		wattroff(wep_win, COLOR_PAIR(2));
		wrefresh(wep_win);
	}
	if (pEncryptionInfo->EncryptionLevel != 0) {
		size_used =
		    (pEncryptionInfo->EncryptionLevel == 1) ? 5 : 13;
#ifndef ATMEL_WLAN
		switch (pEncryptionInfo->WepKeyToUse) {
		case 0:
			mvwprintw(wep_win, 5, 1, "Wep Key One\t\t: %02x",
				  pEncryptionInfo->WepKey1[0]);
			for (i = 1; i < size_used; i++)
				mvwprintw(wep_win, 5, 25 + (i * 3),
					  ":%02X", pEncryptionInfo->WepKey1[i]);
			mvwprintw(wep_win, 5, 41, "\b");
			wrefresh(wep_win);
			break;
		case 1:
			mvwprintw(wep_win, 5, 1, "Wep Key Two \t\t: %02x",
				  pEncryptionInfo->WepKey2[0]);
			for (i = 1; i < size_used; i++)
				mvwprintw(wep_win, 5, 25 + (i * 3),
					  ":%02X", pEncryptionInfo->WepKey2[i]);
			mvwprintw(wep_win, 5, 41, "\b");
			wrefresh(wep_win);
			break;
		case 2:
			mvwprintw(wep_win, 5, 1, "Wep Key Three\t\t: %02x",
				  pEncryptionInfo->WepKey3[0]);
			for (i = 1; i < size_used; i++)
				mvwprintw(wep_win, 5, 25 + (i * 3),
					  ":%02X", pEncryptionInfo->WepKey3[i]);
			mvwprintw(wep_win, 5, 41, "\b");
			wrefresh(wep_win);
			break;
		case 3:
			mvwprintw(wep_win, 5, 1,
				  "\tWep Key Four\t\t: %02x",
				  pEncryptionInfo->WepKey4[0]);
			for (i = 1; i < size_used; i++)
				mvwprintw(wep_win, 5, 25 + (i * 3),
					  ":%02X", pEncryptionInfo->WepKey4[i]);
			mvwprintw(wep_win, 5, 41, "\b");
			wrefresh(wep_win);
			break;
		}
#else
			//mvwprintw(wep_win, 5, 1, "Encryption Key %d\t: %02x", pEncryptionInfo->WepKeyToUse + 1,
			mvwprintw(wep_win, 5, 1, "Encryption Key \t: %02x", 
	  pEncryptionInfo->KeyMaterial[pEncryptionInfo->WepKeyToUse][0]);
			for (i = 1; i < size_used; i++)
				mvwprintw(wep_win, 5, 25 + (i * 3),
					  ":%02X", pEncryptionInfo->KeyMaterial[pEncryptionInfo->WepKeyToUse][i]);
			mvwprintw(wep_win, 5, 41, "\b");
			mvwprintw(wep_win, 5, 41, "\b");
			wrefresh(wep_win);
#endif	// !ATMEL_WLAN

#if 0		
		switch (pEncryptionInfo->WepMode) {
		case 0:
			mvwprintw(wep_win, 6, 1,
				  "Wep Mode\t\t: Optional");
			wrefresh(wep_win);
			break;
		case 1:
			mvwprintw(wep_win, 6, 1, "Wep Mode\t\t: Mandatory");
			wrefresh(wep_win);
			break;
		}
#endif
		switch (pEncryptionInfo->AuthenticationType) {
		case 0x0000:
			mvwprintw(wep_win, 6, 1,
				  "Authentication Type\t: Open System");
			wrefresh(wep_win);
			break;
		case 0x0001:
			mvwprintw(wep_win, 6, 1,
				  "Authentication Type\t: Shared Key");
			wrefresh(wep_win);
			break;
		}
		wattroff(wep_win, A_BOLD);
	}
	wattron(wep_win, A_BOLD);
	mvwhline(wep_win, 9, 1, ACS_HLINE, WIDTH-2);
	wattron(wep_win, COLOR_PAIR(1)); 
	mvwprintw(wep_win, 10, 24, "Advanced Settings");
	wrefresh(wep_win);
	wattroff(wep_win, COLOR_PAIR(1));
	mvwhline(wep_win, 11, 1, ACS_HLINE, WIDTH-2);
	wrefresh(wep_win);
	switch (pAppInfo->PreambleType) {
	case 0:
		mvwprintw(wep_win, 13, 1, "Preamble Type\t\t\t: Long");
	        wrefresh(wep_win);
		break;
	case 1:
		mvwprintw(wep_win, 13, 1, "Preamble Type\t\t\t: Short");
	wrefresh(wep_win);
		break;
	}
	if (pAppInfo->RtsCtsThreshold == 2347) {
		wattron(wep_win, COLOR_PAIR(1)); 
		mvwprintw(wep_win, 14, 44, "(Disabled)");
	wrefresh(wep_win);
		wattroff(wep_win, COLOR_PAIR(1));
	}
	mvwprintw(wep_win, 14, 1, "RtsCts Threshold \t\t: %i",
		  pAppInfo->RtsCtsThreshold);
	wrefresh(wep_win);
	if (pAppInfo->FragmentationThreshold == 2346) {
		wattron(wep_win, COLOR_PAIR(1)); 
		mvwprintw(wep_win, 15, 44, "(Disabled)");
	wrefresh(wep_win);
		wattroff(wep_win, COLOR_PAIR(1));
	}
	mvwprintw(wep_win, 15, 1, "Fragmentation Threshold\t: %i",
		  pAppInfo->FragmentationThreshold);
	wrefresh(wep_win);

}
void DisplayDriverState(WINDOW * conf_win, ULONG StatusCode, int mode, ULONG Mgmt)
{
	if ((StatusCode == 0x05) && (mode == 1)) {
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Associated ");
		return;
	}

	switch (StatusCode) {
	case 0x00:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Initializing");
		break;
	case 0x01:
		mvwprintw(conf_win, 7, 1, "Driver State	\t\t: Scanning ");
		break;
	case 0x02:
		mvwprintw(conf_win, 7, 1, "Driver State	\t\t: Joining ");
		break;
	case 0x03:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Authenticating");
		break;
	case 0x04:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Associating");
		break;
	case 0x05:
		mvwprintw(conf_win, 7, 1, "Driver State	\t\t: Ready");
		break;
	case 0x06:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Station Out of Range");
		break;
	case 0x07:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Disassociating");
		break;
	case 0x08:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Disauthenticating");
		break;
	case 0x09:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Reassociating");
		break;
	case 0x0a:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Forced Joining");
		break;
	case 0x0b:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: ReConfiguring");
		break;
	case 0x0c:
		mvwprintw(conf_win, 7, 1, "Driver State	\t\t: FW_Upgrade");
		break;
	case 0x0d:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Force Joining Failure");
		break;
	case 0x0e:
		mvwprintw(conf_win, 7, 1, "Driver State	\t\t: Resetting");
		break;
	case 0x0f:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Reset Pending");
		break;
	case 0x13:
		mvwprintw(conf_win, 7, 1,
			  "Driver State	\t\t: Radio Off");
		break;
	case 0xf0:
		mvwprintw(conf_win, 7, 1,
			  "Driver State    \t\t: No card Present");
		break;
	case 0xf1:
                if(Mgmt == 0xa0){
		mvwprintw(conf_win, 7, 1, "Driver State\t\t\t: Enable Encryption to join this BSS");
                }else if(Mgmt == 0xa1){
		mvwprintw(conf_win, 7, 1, "Driver State:\t\t\t: Disable Encryption to join this BSS");
                }else{
                    mvwprintw(conf_win, 7, 1, "Driver State	\t\t: ");
                    DisplayErrorMsg(conf_win, StatusCode);
                }
		break;
	default:
		mvwprintw(conf_win, 7, 1, "Driver State	\t\t: ");
		mvwprintw(conf_win, 7, 34, "Not Known yet......		");

	}
}

void DisplayErrorMsg(WINDOW * conf_win, ULONG StatusCode)
{
	switch (StatusCode) {
	case 1:		//C80211_MGMT_SC_Unspecified:
		mvwprintw(conf_win, 7, 1,
			  "Unspecified error in Management Frame...\n");
		break;
	case 10:		//C80211_MGMT_SC_SupportCapabilities:
		mvwprintw(conf_win, 7, 1,
			  "Support Capabilities error in Association Request...");
		break;
	case 11:		//C80211_MGMT_SC_ReassDenied:
		mvwprintw(conf_win, 7, 1, "Re-Association Denied... \n");
		break;
	case 12:		//C80211_MGMT_SC_AssDenied:
		mvwprintw(conf_win, 7, 1, "Association Denied... \n");
		break;
	case 13:		//C80211_MGMT_SC_AuthAlgNotSupported:
		mvwprintw(conf_win, 7, 1,
			  "Authentication Algorithm not supported...");
		break;
	case 14:		//C80211_MGMT_SC_AuthTransSeqNumError:
		mvwprintw(conf_win, 7, 1,
			  "Bad Authentication transaction sequence number...");
		break;
	case 15:		//C80211_MGMT_SC_AuthRejectChallenge:
		mvwprintw(conf_win, 7, 1,
			  "Authentication challenge text rejection...");
		break;
	case 16:		//C80211_MGMT_SC_AuthRejectTimeout:
		mvwprintw(conf_win, 7, 1, "Authentication Timeout...");
		break;
	case 17:		//C80211_MGMT_SC_AssDeniedHandleAP:
		mvwprintw(conf_win, 7, 1,
			  "Access Point can not handle any more stations...");
		break;
	case 18:		//C80211_MGMT_SC_AssDeniedBSSRate:
		mvwprintw(conf_win, 7, 1,
			  "Association Denied (Supported Rates mismatch)...");
		break;
	default:
		mvwprintw(conf_win, 7, 1,
			  "Failed to co-operate with the selected Access Point");
	}
}

int open_sock(void)
{
	int inet_sock = -1;
	int ipx_sock = -1;
	int ax25_sock = -1;
	int ddp_sock = -1;

	inet_sock = socket(AF_INET, SOCK_STREAM, 0);
	ipx_sock = socket(AF_IPX, SOCK_STREAM, 0);
	ax25_sock = socket(AF_AX25, SOCK_STREAM, 0);
	ddp_sock = socket(AF_APPLETALK, SOCK_STREAM, 0);

	if (inet_sock != -1)
		return inet_sock;
	if (ipx_sock != -1)
		return ipx_sock;
	if (ax25_sock != -1)
		return ax25_sock;
	return ddp_sock;
}


int startx = 0;
int starty = 0;

int total;
int n_choices = sizeof(choices) / sizeof(char *);

int main(int argc, char *argv[])
{
	WINDOW *menu_win;
	int highlight = 1;
	int choice = 0;
	uid_t uid;
	int d, sttruth = 0;

	int fd, i, res;
	char welcome[WIDTH];
	DEVICE_CONFIGURATION pAppInfo;
	ENCRYPTION_INFO pEncryptionInfo;
	VERSION_INFO pVersionInfo;
	STATISTICS Stats;
	struct iwreq wrq;
	unsigned char BoardFound = 0;


        uid = getuid();
        if(uid != 0){
          printf("You Must Be root to Run lvnet\n");
          return -EPERM;
        }
	if (argc > 1) {
		if (strncmp(argv[1], "--help", 6) == 0){
                    printf("Usage :\n");
                    printf("\tlvnet [-i] : i equals the interface name. Default atml0\n");
                    return -1;
                }
        }
        
	initscr();
	clear();
	noecho();
	cbreak();
	start_color();
	init_all_pairs();
	refresh();

	memset(&wrq, 0, sizeof(struct iwreq));
	signal(SIGINT, no_quit);
	for (i = 0; i < n_choices; ++i) {
		total += strlen(choices[i]);
	}
	total = (WIDTH - total) / n_choices;

#if 0
	if (argc > 1) {
		if ((strncmp(argv[1], "f", 1) == 0)
		    || (strncmp(argv[1], "-f", 2) == 0)) {
			read_conf(&str_list);
		} else if (strncmp(argv[1], "u", 1) == 0) {
			CardRequested = USB;
		} else if (strncmp(argv[1], "u", 1) == 0) {
			CardRequested = PCMCIA;
		} else {
			return -1;
		}
		return 0;
	}
#endif
	fd = open_sock();
	if (fd < 0) {
		ErrorWin("No Card Found! Quitting...");
		clear();
		endwin();
		exit(EXIT_FAILURE);
	}

	if (COLS<80 || LINES<25) {
		clear();
		endwin();
		printf("Sorry, your console doesn't seem to satisfy \n\
			\rthe minimum size requirements: 80x25\n");
		return -1;
	}

        if(argc > 1){
            int arglen, c;
		if (strncmp(argv[1], "-i", 2) == 0) {
                    if(strncmp(argv[2], "atml", 4) == 0){
                        arglen = strlen(argv[2]);
                        for( c = 4 ; c < arglen; c++) {
                            if (isdigit(argv[2][c]) == 0){
				ErrorWin("Invalid Interface");
                                clear();
                                endwin();
		                exit(EXIT_FAILURE);
                            }
                        }
                        strcpy(wrq.ifr_name, argv[2]);
                        BoardFound |= (1 << i);
                    }
                }
         } else {

                    for (i = 0; i < 8; i++) {
                            sprintf(ifname, "atml%d", i);
                            strcpy(wrq.ifr_name, ifname);

                            res = ioctl(fd, SIOCGIWNAME, &wrq);
                            if (res < 0)
                                    continue;

                            if ((strncmp(wrq.u.name, "ATMEL USB503A", 13) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL INTERSIL", 14) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL RFMD503A", 14) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL RFMD505", 13) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL RFMD505A", 14) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL MX 505A", 13) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL 2958505", 13) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL RFMD", 10) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL REVD", 10) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL REVE", 10) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL 504", 9) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL 504A", 10) != 0) &&
                                (strncmp(wrq.u.name, "ATMEL PCI", 10) != 0)
                                )
                                    continue;
                            BoardFound |= (1 << i);
                            break;
                    }
         }

	if (!BoardFound) {
		ErrorWin("No Atmel Card Found Inserted!");
		clear();
		endwin();
		return -ENODEV;
	}

	if (Get_Config(&pAppInfo, fd, wrq.ifr_name) != 0) {
		ErrorWin("Get Configuration failed...");
		clear();
		endwin();
		return -ENODEV;
	}
	if (Get_Stats(&Stats, fd, wrq.ifr_name)) {
		ErrorWin("Get Statistics failed...");
		clear();
		endwin();
		return -ENODEV;
	}
	if (Get_Wep(&pEncryptionInfo, fd, wrq.ifr_name)) {
 		ErrorWin("Get Wep Info Failed...");
		clear();
		endwin();
		return -ENODEV;
	}
	if (Get_Ver(&pVersionInfo, fd, wrq.ifr_name)) {
		ErrorWin("Get Version failed...");
		clear();
		endwin();
		return -ENODEV;
	}
	//startx = (90 - WIDTH) / 2; 
	//starty = (9 - HEIGHT) / 2;
	startx = 0;
	starty = 3;

	menu_win = newwin(HEIGHT, WIDTH, starty, startx);

	keypad(menu_win, TRUE);
	keypad(stdscr, TRUE);
	attron(A_BOLD);

	menu_win = newwin(HEIGHT, WIDTH, starty, startx);

	keypad(menu_win, TRUE);
	keypad(stdscr, TRUE);
	attron(A_BOLD);
	attron(COLOR_PAIR(2));
	sprintf(welcome, "%s Wireless Card Monitor Utility for interface %s - Card Type %s\n",
          CompanyName, wrq.ifr_name, &wrq.u.name[6]); 
	CENTER(stdscr, 0, welcome)
	mvprintw(1, 9, "Driver Version :");
	attron(COLOR_PAIR(3)); //CHNG
	mvprintw(1, 26, "%d.%d.%d.%d ", pVersionInfo.DriverMajorVersion,
		 pVersionInfo.DriverMinorVersion,
		 pVersionInfo.DriverSubVersion, pVersionInfo.DriverBuild);
	attroff(COLOR_PAIR(3)); //CHNG
	attron(COLOR_PAIR(2));
	mvprintw(1, 38, "Firmware Version :");
	attroff(COLOR_PAIR(2));
	attron(COLOR_PAIR(3)); //CHNG
	mvprintw(1, 57, "%d.%d.%d.%d", pVersionInfo.FwMajorVersion,
		 pVersionInfo.FwMinorVersion, pVersionInfo.FwSubVersion,
		 pVersionInfo.FwBuild);
	attroff(COLOR_PAIR(3)); //CHNG
  
  WATTR(stdscr, COLOR_PAIR(2),
  CENTER(stdscr, 2, "Use arrow keys to go left and right. Press enter to select a choice <F1:Exit>") )
	attroff(A_BOLD);
	refresh();
	print_menu(menu_win, highlight);

	while (1) {
		d = wgetch(menu_win);
		sttruth = 0;
		switch (d) {
		case KEY_LEFT:
			if (highlight == 1)
				highlight = n_choices;
			else
				--highlight;
			break;
		case KEY_RIGHT:
			if (highlight == n_choices)
				highlight = 1;
			else
				++highlight;
			break;
		case 10:
			choice = highlight;
			sttruth = 1;
			break;
#ifndef LOW_RES      
    case KEY_F(6):
      if (choice == 5 && justa_win != NULL) {
        wclear(justa_win);
        StartSiteSurvey(fd, wrq.ifr_name);
      }
      break;
#endif  //NOT LOW_RES    
		default:
			refresh();
			break;
		}
		print_menu(menu_win, highlight);
		if ((choice == n_choices) || (d == KEY_F(1))) {	/* User did a choice come out of the infinite loop */
			clear();
			refresh();
			exit_win = newwin(6, 50, 10, 15);
			box(exit_win, 0, 0);
			wattron(exit_win, A_BOLD);
			wattron(exit_win, COLOR_PAIR(2));
			mvwprintw(exit_win, 1, 14, "You Exited Normally");
			mvwprintw(exit_win, 2, 22, "FROM");
			mvwprintw(exit_win, 3, 9,
				  "ATMEL's Card Configuration tool");
			wattroff(exit_win, COLOR_PAIR(2));
			wattroff(exit_win, A_BOLD);
			wrefresh(exit_win);
			refresh();
			break;
		}
		if (sttruth == 1) {
			if (choice == n_choices) {
				sttruth = 0;
				break;
			}

			switch (choice) {
			case 1:
				set_win = create_newwin(WINHEIGHT, WIDTH, 6, 0); 
				//wattron(set_win, A_BOLD);
				Get_Stats(&Stats, fd, wrq.ifr_name);
				Get_Config(&pAppInfo, fd, wrq.ifr_name);
				Print_Stats(set_win, &pAppInfo, &pEncryptionInfo,
					    &Stats);
				//wattroff(set_win, A_BOLD);
				wrefresh(set_win);
				refresh();
				break;
			case 2:
				attron(A_BOLD);
				Get_Stats(&Stats, fd, wrq.ifr_name);
				Get_Config(&pAppInfo, fd, wrq.ifr_name);
				Print_Wep_Stats(wep_win, &pEncryptionInfo, &pAppInfo,
						&Stats);
				attroff(A_BOLD);
				refresh();
				break;
			case 3:
				WepDlg(&pAppInfo, wrq.ifr_name, fd,
				       &pEncryptionInfo);
				refresh();
				break;
			case 4:
				read_ioctls_wlan(&pAppInfo, &pEncryptionInfo, fd,
						 wrq.ifr_name);
				refresh();
				break;
#ifndef LOW_RES        
			case 5:
				justa_win = create_newwin(WINHEIGHT, WIDTH, 6, 0); 
          HEADER( justa_win, "No Site Survey in Progress")
	        WATTR( justa_win, A_BLINK | COLOR_PAIR(1), 
          CENTER(justa_win, 9, "Press <F6> to Start Scanning") )
				wrefresh(justa_win);
				refresh();
				break;
#endif //NOT LOW_RES

			default:
				refresh();
				break;
			}
			sttruth = 0;
		}
	}
	signal(SIGINT, no_quit);

	clrtoeol();
	refresh();
	endwin();
	return 0;
}


void print_menu(WINDOW * menu_win, int highlight)
{
	int x, y, i;
	x = 2;
	y = 2;
	box(menu_win, 0, 0);
	noecho();
	for (i = 0; i < n_choices; ++i) {
		if (highlight == i + 1) {	/* High light the present choice */
			wattron(menu_win, A_REVERSE | A_BOLD);
			mvwprintw(menu_win, 1, x, "%s", choices[i]);
			wattroff(menu_win, A_REVERSE | A_BOLD);
		} else
			mvwprintw(menu_win, 1, x, "%s", choices[i]);
		x += (strlen(choices[i]) + total);
	}
	wrefresh(menu_win);
}

WINDOW *create_newwin(int height, int width, int starty, int startx)
{
	WINDOW *local_win;

	local_win = newwin(height, width, starty, startx);
	box(local_win, 0, 0);
	/* 0, 0 gives default characters
	 * for the vertical and horizontal
	 * lines            */
	wrefresh(local_win);	/* Show that box */

	return local_win;
}

WINDOW *create_inputwin(int height, int width, int starty, int startx)
{
	WINDOW *local_win;

	local_win = newwin(height, width, starty, startx);
//	box(local_win, 0, 0);
	/* 0, 0 gives default characters
	 * for the vertical and horizontal
	 * lines            */
	wrefresh(local_win);	/* Show that box */

	return local_win;
}

void destroy_win(WINDOW * local_win)
{
	wborder(local_win, ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ');
	wrefresh(local_win);
	delwin(local_win);
}

void print_my_menu(WINDOW * my_win, int reverse)
{
	int x, y, i;
	x = 4;
	y = 3;
	box(my_win, 0, 0);
	HEADER(my_win, "Card Configuration Menu")
	for (i = 0; i < config_choices; i++) {
		if (reverse == i + 1) {	/* High reverse the present choice */
			wattron(my_win, A_BOLD);
			wattron(my_win, A_REVERSE);
			mvwprintw(my_win, y, x, "%s", conf_choices[i]);
			wattroff(my_win, A_REVERSE);
			wattroff(my_win, A_BOLD);
		} else
			mvwprintw(my_win, y, x, "%s", conf_choices[i]);
		y++;
	}
	wrefresh(my_win);
}


void no_quit(int signum)
{
	signal(SIGINT, no_quit);
	signal(SIGINT, SIG_IGN);
}


