/* $Id: stdinclude.h,v 1.9 2004/08/25 12:45:53 tmpetsos Exp $ */
/***************************************************************************************
	Copyright 2000-2001 ATMEL Corporation.
	
	This file is part of atmel wireless lan drivers.

    Atmel wireless lan drivers is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Atmel wireless lan drivers is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Atmel wireless lan drivers; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

**************************************************************************************/

/****************************************
	Callback functions -- callbacks.c
****************************************/
#if (LINUX_VERSION_CODE < 0x020500)
void RxCallback(purb_t purb);
void TxOkCB(purb_t purb);
void ctrl_callback(struct urb *purb);
void GetCmd_callback(purb_t purb);
#else
int update_usb_intf_descr(struct usb_device *);
void RxCallback(purb_t purb, struct pt_regs *regs);
void TxOkCB(purb_t purb, struct pt_regs *regs);
void ctrl_callback(struct urb *purb, struct pt_regs *regs);
void GetCmd_callback(purb_t purb, struct pt_regs *regs);
#endif

/**************************************
	Commands functions -- command.c
**************************************/
void GetOperationalRates(PVNet_ADAPTER Adapter);
int SetAutoRateFallback(PVNet_ADAPTER Adapter);
int UsbStartIBSS(PVNet_ADAPTER Adapter);
int UsbScan(PVNet_ADAPTER Adapter);
int UsbJoin(PVNet_ADAPTER Adapter);
int GetOpMode(PVNet_ADAPTER Adapter);
int GetHWCfg(PVNet_ADAPTER Adapter);
int GetMIBvalue(PVNet_ADAPTER Adapter, USHORT Mib, USHORT bytes);
int SetMIB_NewBSSID_OK(PVNet_ADAPTER Adapter);
int StartUp(PVNet_ADAPTER Adapter);
int GetCmdStatus(PVNet_ADAPTER Adapter, UCHAR CmdID);
int SetRadio(PVNet_ADAPTER Adapter, BOOLEAN EnableRadio);
int SetPreamble(PVNet_ADAPTER Adapter);
int SetIRoaming(PVNet_ADAPTER Adapter);
int SetTxPower(PVNet_ADAPTER Adapter);
int SetPowerMgmtMode(PVNet_ADAPTER Adapter);
int SetAssocID(PVNet_ADAPTER Adapter);
int SetListenInterval(PVNet_ADAPTER Adapter);
int SetFragThreshold(PVNet_ADAPTER Adapter);
int SetRTSThreshold(PVNet_ADAPTER Adapter);
void UsbSelectBSS(PVNet_ADAPTER Adapter);
int GetDFUState(PVNet_ADAPTER Adapter);
int GetDFUStatus(PVNet_ADAPTER Adapter);
int DownLoadInternal(PVNet_ADAPTER Adapter);
int DownLoadExternal(PVNet_ADAPTER Adapter);
int Remap(PVNet_ADAPTER Adapter);
int DFUdetach(PVNet_ADAPTER Adapter);
int SetMacAddress(PVNet_ADAPTER Adapter);
int SetWEPvalue(PVNet_ADAPTER Adapter);
void GetNewBSS(PVNet_ADAPTER Adapter);
void GetChannelList(PVNet_ADAPTER Adapter);
int SetEncryptionStatus(PVNet_ADAPTER Adapter, BOOLEAN SetKey, BOOLEAN RemoveAllKeys, ULONG KeyIndex);
BOOLEAN RemoveEncryptionSettings(PVNet_ADAPTER Adapter);

/*****************************
	linux_usb.c
*****************************/
void UpdateAppInfo(PVNet_ADAPTER Adapter,
		   PDEVICE_CONFIGURATION pDevConfig);


/*****************************
	rx.c
*****************************/
int UsbRxInit(PVNet_ADAPTER Adapter);
void TimerExpired(ULONG a);
void RxData(PVNet_ADAPTER Adapter);
VOID MgmtFrameProcessing(PVNet_ADAPTER Adapter, UCHAR FrameSubType);
//
// ParseBeaconOrProbeRespone
//
VOID ParseBeaconOrProbeResponse(PVNet_ADAPTER Adapter, PSITE_SURVEY_INFO BSSList, PUCHAR FrameBody, UCHAR tmpChannel, PUCHAR BSSID, 
							   USHORT CapabilityInformation, USHORT FrameLength, USHORT i);
/*****************************
	tx.c
*****************************/
int SendAuthRequest(PVNet_ADAPTER Adapter);
int SendReAssocRequest(PVNet_ADAPTER Adapter);
int SendAssocRequest(PVNet_ADAPTER Adapter);
TX_LIST *AllocPacket(PVNet_ADAPTER Adapter, USHORT length);
void DeQueueTxPacket(PVNet_ADAPTER Adapter, TX_LIST * new_tx);
void VNetDumpUrb(purb_t purb);
void DropPendingTxPackets(PVNet_ADAPTER Adapter);
void Ethernet2Wireless(PVNet_ADAPTER Adapter, PTX_LIST NewTxL);

/**************************
	vnet.c
**************************/
void init_CRCtable(PVNet_ADAPTER Adapter);
void SetParameters(PVNet_ADAPTER Adapter);
ULONG Calculate_CRC32(PUCHAR p, ULONG FrameLength, PULONG crctab);
void VnetReleaseResources(PVNet_ADAPTER Adapter);
void ChangeState(PVNet_ADAPTER Adapter, UCHAR State);
int InitDevice(PVNet_ADAPTER Adapter);
UCHAR AsciiToByte(UCHAR Ascii1, UCHAR Ascii2);
BOOLEAN ValidateChannel(PVNet_ADAPTER Adapter, UCHAR Channel);
int ChangeConfiguration(PVNet_ADAPTER Adapter,
			DEVICE_CONFIGURATION * pDevConfig);

/**************************
	vnet_reset.c
**************************/
int __usb_atmel_reset_device(struct usb_device *dev);
int __usb_atmel_get_configuration(struct usb_device *dev);
int __usb_atmel_set_configuration(struct usb_device *dev, int configuration);

/**************************
	vnet_kernel.c
**************************/
void VNetIf_queue(struct net_device *dev, UCHAR c);
int VNetSchedule(PVNet_ADAPTER Adapter, ULONG flag);
int InitAdapter(PVNet_ADAPTER Adapter);
int VnetUsbReset(PVNet_ADAPTER Adapter);
int rx_kernel_part(PVNet_ADAPTER Adapter, struct sk_buff **skb,
		   USHORT PacketLength, UCHAR DataOffset);
int VNetAllocMem(void **Ptr, USHORT size);
void VnetTimer(PVNet_ADAPTER Adapter, UCHAR timeout);
void VNetFreeSkb(struct sk_buff *skb);
void VNetFree(void *ptr);
BOOLEAN IsEncryptionEnabled(PSECURITY_INFO pSecurityInfo);

/* vnetusba.c */
void mod_use(UCHAR a, PVNet_ADAPTER Adapter);
char *ssid2str(char *buf, char *ssid, int len);
char *buf2str(char *str, void *buf, int len);
void VNetGetSystemTime(PVOID tCurrentTime);


BOOLEAN WPA_IsOkToConnect(MIC_BLACK_LIST* MicBlackList, unsigned char ListEntries, unsigned char* pValidListEntries, unsigned char* pBSSID, void* pCurrentTime);

BOOLEAN WPA_AddAPInBlackList(MIC_BLACK_LIST* MicBlackList,
unsigned char ListEntries, unsigned char* pValidListEntries, unsigned char* pBSSID, void* pTime);
BOOLEAN WPA_IsOkToConnect(MIC_BLACK_LIST* MicBlackList, unsigned char ListEntries, unsigned char* pValidListEntries, unsigned char* pBSSID, void* pCurrentTime);


void WPA_addMICToPacket(UCHAR *packet,UINT msgLength,UCHAR *micKey);
UCHAR WPA_validateMic(UCHAR *packet,UINT msgLength, UCHAR *micKey);
void ParseEAPOLPacket(PUCHAR pbEapolMsg, PUCHAR pbLeapChallenge, PUCHAR pbPacket, BOOLEAN fReceived, BOOLEAN fDisplay);
BOOLEAN StoreEapolPacket(PEAPOL_BUFFER pEapolBuffer, PUCHAR pbRxBuffer, ULONG dwRxBufferLength);
int atmel_assoc_info_event (PVNet_ADAPTER Adapter);
int atmel_scan_info_event (PVNet_ADAPTER Adapter);
BOOLEAN GetEncryptionMIB(PVNet_ADAPTER Adapter);

#define EAPOL_NONE          0
#define EAPOL_RX_HANDSHAKE_MSG1   1
#define EAPOL_TX_HANDSHAKE_MSG2   2
#define EAPOL_RX_HANDSHAKE_MSG3   3
#define EAPOL_TX_HANDSHAKE_MSG4   4
#define EAPOL_RX_GROUP_UPDATE_MSG1  5
#define EAPOL_TX_GROUP_UPDATE_MSG2  6
#define EAPOL_TX_MIC_ERROR_MSG    7
#define EAPOL_LOG_OFF         8

#define EAP_REQUEST         10
#define EAP_RESPONSE        11
#define EAP_SUCCESS         12
#define EAP_REJECT          13
#define EAP_START         14

#define LEAP_CHALLENGE        15

#define LEAP_CHALLENGE_ON     1
#define LEAP_CHALLENGE_OFF      0

BOOLEAN StoreEapolPacket(PEAPOL_BUFFER pEapolBuffer, PUCHAR pbRxBuffer, ULONG dwRxBufferLength);
void 	ParseEAPOLPacket(PUCHAR pbEapolMsg, PUCHAR pbLeapChallenge, PUCHAR pbPacket, BOOLEAN fReceived, BOOLEAN fDisplay);
PUCHAR 	RxProtocolConversion(PUCHAR pbInputBuffer, ULONG dwBufferLength, UCHAR bOperatingMode, PULONG pdwPacketSize);
BOOLEAN GetChannelFromBeaconOrProbe(PUCHAR pBeaconOrProbeFrame, PUCHAR pChannel);
BOOLEAN GetSupportedRatesfromBeaconOrProbe(PUCHAR pSupportedRates, PUCHAR pSupportedRatesLength, PUCHAR pBeaconOrProbeFrame, USHORT ElementOffset);
BOOLEAN GetSSIDfromBeaconOrProbe(PUCHAR pbSSID, PUCHAR pbSSIDlength, PUCHAR pbBeaconOrProbeFrame);
BOOLEAN GetElementFromBeaconOrProbe(PUCHAR pbBeaconOrProbeFrame, USHORT wFrameLen, UCHAR bElementID, PUCHAR pbOUI, PUCHAR pbElementBody, PUSHORT pwElementBodyLen);
#ifdef WPA2
VOID 	WPA2_FlashPMKIDCandidateList(PPMKID_CANDIDATELIST pPMKIDCandidateList);
BOOLEAN	WPA2_ComparePMKIDCandidateLists(PSECURITY_INFO pSecurityInfo);
BOOLEAN WPA2_BuildPMKIDCandidateList(PPMKID_CANDIDATELIST pPMKIDCandidateList, BSS_INFO_EX* pBSSinfoEx, UCHAR bBSSinfoExEntries, BSS_INFO_EX* pCurrentBSSinfo);
ULONG 	WPA2_BuildAuthEncryptionCapability(P_802_11_AUTHENTICATION_ENCRYPTION pAuthEncryptionList);
USHORT 	WPA2_AddPMKsInElement(PSECURITY_INFO pSecurityInfo, PBSS_INFO_EX pBssInfo, PUCHAR pbIEBuffer);
BOOLEAN WPA2_AddPMKIDInList(PSECURITY_INFO pSecurityInfo, P__802_11_PMKID pPMKID);
#endif
BOOLEAN IsTxKeyAvailable(PSECURITY_INFO pSecurityInfo);
VOID 	SelectCiphers(PSECURITY_INFO pSecurityInfo, BOOLEAN fIsBroadcast, BOOLEAN* pfTxEapPending, BOOLEAN fForceUnencrypted, PUCHAR pbCipherType, PUCHAR pbCipherLength);
BOOLEAN MatchSecuritySettings(PSECURITY_INFO pSecurityInfo, PBSS_INFO_EX pBssInfo, UCHAR bOperatingMode, STATISTICS* pStats);
void 	AddIEsInRequest(PUCHAR pbFrameBody, PUSHORT pwBytesAdded, PSECURITY_INFO pSecurityInfo, PBSS_INFO_EX pBssInfo, PUCHAR pbIPAddress, USHORT wCwMin, USHORT wCwMax);
void 	BuildNullFrame(PUCHAR pbFrame, PASSOCIATION_INFO pAssociationInfo, PUSHORT pwFrameLength);
void 	BuildDisAssociationRequestFrame(PUCHAR pbFrame, PASSOCIATION_INFO pAssociationInfo, USHORT wReasonCode, PUSHORT pwFrameLength);
void 	BuildReAssociationRequestFrame(PUCHAR pbFrame, PASSOCIATION_INFO pAssociationInfo, PSECURITY_INFO pSecurityInfo, PUSHORT pwFrameLength);
void 	BuildAssociationRequestFrame(PUCHAR pbFrame, PASSOCIATION_INFO pAssociationInfo, PSECURITY_INFO pSecurityInfo, PUSHORT pwFrameLength);
void 	BuildDeAuthenticationRequestFrame(PUCHAR pbFrame, PASSOCIATION_INFO pAssociationInfo, USHORT wReasonCode, PUSHORT pwFrameLength);
void 	BuildAuthenticationRequestFrame(PUCHAR pbFrame, PAUTHENTICATION_INFO pAuthenticationInfo, PASSOCIATION_INFO pAssociationInfo, PSECURITY_INFO pSecurityInfo, PUSHORT pwFrameLength);
BOOLEAN IsEncryptionEnabled(PSECURITY_INFO pSecurityInfo);
void 	BuildMgmtFrameHeader(PUCHAR pbHeader, UCHAR bFrameSubType, PAUTHENTICATION_INFO pAuthenticationInfo, PASSOCIATION_INFO pAssociationInfo, PSECURITY_INFO pSecurityInfo);
